#ifndef __PMC_SOCK_H__
#define __PMC_SOCK_H__

#include <btron/bsocket.h>

#define socklen_t	int
#ifndef EXPORT
#define EXPORT 
#endif
#ifndef EXPORT
#define EXPORT
#endif
#ifndef HOST_NOT_FOUND
#define HOST_NOT_FOUND 1
#endif
#ifdef __cplusplus
extern "C" {
#endif
EXPORT int socket(int domain, int type, int protocol);
EXPORT int bind(int sockfd, struct sockaddr *addr, int addrlen);
EXPORT int listen(int sockfd, int queue_len);
EXPORT int accept(int sockfd, struct sockaddr *addr, int *addr_len);
EXPORT int connect(int sockfd, struct sockaddr *addr, int addr_len);
EXPORT int send(int sockfd, void *buffer, int msg_len, int options);
EXPORT int sendto(int sockfd, void *msg, int len, int options, struct sockaddr *addr, int addr_len);
EXPORT int recv(int sockfd, void *buf, int maxbuf, int options);
EXPORT int recvfrom(int sockfd, void *buf, int buf_len, int options, struct sockaddr *adr, int *addr_len);
EXPORT int shutdown(int sockfd, int how);
EXPORT int setsockopt(int sd, int level, int optname, const void *optval, int optlen);
EXPORT int select(int hi_fd, fd_set *readfds, fd_set *writefds, fd_set *exceptfds, struct timeval *timeout);
EXPORT int closesocket(int fd);
EXPORT int gethostbyaddr(char *addr, int len, int type, HOSTENT *hp, char *buf);
EXPORT int getpeername(int s, SOCKADDR *nam, int *namlen);
EXPORT int getsockname(int s, SOCKADDR *nam, int *namlen);
EXPORT int getsockopt(int s, int level, int optnam, char *optval, int *optlen);
EXPORT int gethostname(char  *nam, int len);
EXPORT struct hostent * gethostbyname(const char  * name);
EXPORT int fcntl(int fd, int cmd, int arg);
#ifdef __cplusplus
}
#endif

#endif
